//============================================================================
// Name        : TesteCliente.cpp
// Author      :
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <stdlib.h>
#include <fstream>
#include <allegro.h>
#include <stdio.h>
#include "Criptografia.h"
#include "Servidor.h"
#include <coss/CosNaming.h>

#include "Teclado.h"
#include "Pintor.h"

using namespace std;

int X = 800;
int Y = 600;

inline void init() {
	allegro_init();
	set_color_depth(16);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, X, Y, 0, 0);

	install_timer();
	install_keyboard();
	install_mouse();
	install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT, NULL);
}

inline void deinit() {
	clear_keybuf();
	allegro_exit();
}

int main() {

	FILE * in = fopen("Client.in", "r");

	char par1[100];
	char par2[100];
	char par3[100];

	fscanf(in, "%s", par1);
	fscanf(in, "%s", par2);
	fscanf(in, "%s", par3);
	fclose(in);
	char *argv[] = { par1, par2, par3 };
	int argc = 3;

	cout << "Cria orb" << endl;
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

	cout << "resolve initial references" << endl;
	CORBA::Object_var nsobj = orb->resolve_initial_references("NameService");

	cout << "name context" << endl;
	CosNaming::NamingContext_var nc = CosNaming::NamingContext::_narrow(nsobj);

	CosNaming::Name name;
	name.length(1);

	name[0].id = (const char*) "myServidor";
	name[0].kind = (const char*) "";

	CORBA::Object_var obj;
	obj = nc->resolve(name);

	Servidor_var servidor = Servidor::_narrow(obj);
	CORBA::Long a = 2;
	CORBA::Long b = -1;
	CORBA::Long retorno;

	cout << "inicia parte allegro" << endl;

	init();

	Teclado *teclado = new Teclado(INTERFACE_PL1);
	Pintor *pintor = new Pintor();

	//while (!key[KEY_ESC]) {
		a = (CORBA::Long) teclado->verificaEntradas();
		cout << a << endl;

		retorno = servidor->processaJogo(a, b);
		cout << retorno << endl;
		pintor->atualizaDados(&servidor->getTLogica());
		if (retorno == -1)
		//	break;
	//}

	cout << retorno << endl;

	deinit();

	return 0;
}
END_OF_MAIN()
