#include "Logica.h"

Logica:: Logica(int numPlayer){

    this->estagio = new Estagio();
    this->numeroDeJogadores = numPlayer;
    this->estagioAtual =    1 ;
    this->minhocasComidas = 0 ;
    this->pausado = false;

    this->aux1[0]   = new ObjetoPalco ( estagio, GALINHA1, this->estagio->xInicio1, this->estagio->yInicio, 60, 60, 5, true) ;
    this->aux1[1]   = new ObjetoPalco ( estagio, GALINHA2, this->estagio->xInicio2, this->estagio->yInicio, 60, 60, 5, false) ;
    this->aux1[2]   = new ObjetoPalco ( estagio, CARRO, 0 , 95, 75, 70, 6, true) ;
    this->aux1[2]->direcao = DIREITA;
    this->aux1[3]   = new ObjetoPalco ( estagio, CARRO, 363 , 95, 75, 70, 6, true) ;
    this->aux1[3]->direcao = DIREITA;

    this->aux1[4]   = new ObjetoPalco ( estagio, CARRO, 725 , 195, 75, 70, 6, true) ;
    this->aux1[5]   = new ObjetoPalco ( estagio, CARRO, 437 , 195, 75, 70, 6, true) ;

    this->aux1[4]->direcao = ESQUERDA;
    this->aux1[5]->direcao = ESQUERDA;

    this->aux1[6]   = new ObjetoPalco ( estagio, CARRO, 0 , 295, 75, 70, 6, true) ;
    this->aux1[7]   = new ObjetoPalco ( estagio, CARRO, 363 , 295, 75, 70, 6, true) ;

    this->aux1[6]->direcao = DIREITA;
    this->aux1[7]->direcao = DIREITA;

    this->aux1[8]   = new ObjetoPalco ( estagio, CARRO, 725 , 395, 75, 70, 6, true) ;
    this->aux1[9]   = new ObjetoPalco ( estagio, CARRO, 437 , 395, 75, 70, 6, true) ;

    this->aux1[8]->direcao = ESQUERDA;
    this->aux1[9]->direcao = ESQUERDA;

    this->aux1[10]  = new ObjetoPalco ( estagio, CARRO, 0 , 615, 75, 70, 6, true) ;
    this->aux1[11]  = new ObjetoPalco ( estagio, CARRO, 363 , 615, 75, 70, 6, true) ;

    this->aux1[10]->direcao = DIREITA;
    this->aux1[11]->direcao = DIREITA;

    this->aux1[12]  = new ObjetoPalco ( estagio, CARRO, 725 , 715, 75, 70, 6, true) ;
    this->aux1[13]  = new ObjetoPalco ( estagio, CARRO, 437 , 715, 75, 70, 6, true) ;

    this->aux1[12]->direcao = ESQUERDA;
    this->aux1[13]->direcao = ESQUERDA;

    this->aux1[14]  = new ObjetoPalco ( estagio, CARRO, 0 , 815, 75, 70, 6, true) ;
    this->aux1[15]  = new ObjetoPalco ( estagio, CARRO, 363 , 815, 75, 70, 6, true) ;

    this->aux1[14]->direcao = DIREITA;
    this->aux1[15]->direcao = DIREITA;

    this->aux1[16]  = new ObjetoPalco ( estagio, CARRO, 725 , 915, 75, 70, 6, true) ;
    this->aux1[17]  = new ObjetoPalco ( estagio, CARRO, 437 , 915, 75, 70, 6, true) ;

    this->aux1[16]->direcao = ESQUERDA;
    this->aux1[17]->direcao = ESQUERDA;

    this->aux1[18]  = new ObjetoPalco ( estagio, MINHOCA, (rand() % (800- 35)), 930, 35, 40, 0, true) ;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Estagio 2


//TODO  ----

    this->aux2[0]   = new ObjetoPalco ( estagio, GALINHA1, this->estagio->xInicio1, this->estagio->yInicio, 75, 75, 5, true) ;
    this->aux2[1]   = new ObjetoPalco ( estagio, GALINHA2, this->estagio->xInicio2, this->estagio->yInicio, 75, 75, 5, false) ;

    this->aux2[2]   = new ObjetoPalco ( estagio, RIO, 0 , 0 , 800, 400,    0, true) ;

    this->aux2[3]   = new ObjetoPalco ( estagio, RIO, 0 , 805, 800, 190,   0, true) ;

    this->aux2[4]   = new ObjetoPalco ( estagio, CARRO, 0   , 615, 75, 70, 6, true) ;
    this->aux2[5]   = new ObjetoPalco ( estagio, CARRO, 363 , 615, 75, 70, 6, true) ;

    this->aux2[4]->direcao = DIREITA;
    this->aux2[5]->direcao = DIREITA;

    this->aux2[6]   = new ObjetoPalco ( estagio, CARRO, 725 , 715, 75, 70, 6, true) ;
    this->aux2[7]   = new ObjetoPalco ( estagio, CARRO, 437 , 715, 75, 70, 6, true) ;

    this->aux2[6]->direcao = ESQUERDA;
    this->aux2[7]->direcao = ESQUERDA;


    this->aux2[8]   = new ObjetoPalco ( estagio, TRONCO, 0 , 0, 150, 100, 5, true) ;
    this->aux2[9]   = new ObjetoPalco ( estagio, TRONCO, 325 , 0 , 150, 100, 5, true) ;

    this->aux2[8]->direcao = DIREITA;
    this->aux2[9]->direcao = DIREITA;

    this->aux2[10]  = new ObjetoPalco ( estagio, TRONCO, 1 , 100 , 150, 100, 5,   true) ;
    this->aux2[11]  = new ObjetoPalco ( estagio, TRONCO, 266 , 100 , 150, 100, 5, true) ;
    this->aux2[12]  = new ObjetoPalco ( estagio, TRONCO, 532 , 100 , 150, 100, 5, true) ;

    this->aux2[10]->direcao = ESQUERDA;
    this->aux2[11]->direcao = ESQUERDA;
    this->aux2[12]->direcao = ESQUERDA;


    this->aux2[13]  = new ObjetoPalco ( estagio, TRONCO, 0 , 200 , 150, 100, 5, true) ;
    this->aux2[14]  = new ObjetoPalco ( estagio, TRONCO, 325 , 200 , 150, 100, 5, true) ;

    this->aux2[13]->direcao = DIREITA;
    this->aux2[14]->direcao = DIREITA;

    this->aux2[15]  = new ObjetoPalco ( estagio, TRONCO, 1 , 300 ,   150, 100, 5, true) ;
    this->aux2[16]  = new ObjetoPalco ( estagio, TRONCO, 266 , 300 , 150, 100, 5, true) ;
    this->aux2[17]  = new ObjetoPalco ( estagio, TRONCO, 532 , 300 , 150, 100, 5, true) ;

    this->aux2[15]->direcao = ESQUERDA;
    this->aux2[16]->direcao = ESQUERDA;
    this->aux2[17]->direcao = ESQUERDA;


////
    this->aux2[18]  = new ObjetoPalco ( estagio, TRONCO, 0 , 805 , 140, 95, 5, true) ;
    this->aux2[19]  = new ObjetoPalco ( estagio, TRONCO, 325 , 805 , 140, 95, 5, true) ;

    this->aux2[18]->direcao = DIREITA;
    this->aux2[19]->direcao = DIREITA;

    this->aux2[20]  = new ObjetoPalco ( estagio, TRONCO, 1 , 900 , 140, 95, 5, true) ;
    this->aux2[21]  = new ObjetoPalco ( estagio, TRONCO, 266 , 900 , 140, 95, 5, true) ;
    this->aux2[22]  = new ObjetoPalco ( estagio, TRONCO, 532 , 900 , 140, 95, 5, true) ;

    this->aux2[20]->direcao = ESQUERDA;
    this->aux2[21]->direcao = ESQUERDA;
    this->aux2[22]->direcao = ESQUERDA;


    this->aux2[23]  = new ObjetoPalco ( estagio, MINHOCA, (rand() % (800- 35)) , 930, 35, 40, 0, true) ;



    this->noPalco = aux1;

    if (numPlayer == 2){
        this->aux1[1]->visivel = true;
        this->aux2[1]->visivel = true;
    }
}

int Logica:: processar(int digitado1, int digitado2){

    int size;

    if (digitado1 == PL1_PAUSE || (digitado2 == PL2_PAUSE && this->numeroDeJogadores ==2)){
        if(this->pausado){
            this->pausado = false;
        }
        else{
            this->pausado = true;
        }
    }

    if (this->pausado){
        return true;
    }

    if (this->numeroDeJogadores == 2){

        if (digitado2 == PL2_BAIXO){
            this->noPalco[1]->andarParaBaixo();
        }
        else if(digitado2 == PL2_CIMA){
            this->noPalco[1]->andarParaCima();
        }
        else if(digitado2 == PL2_ESQUERDA){
            this->noPalco[1]->andarParaEsquerda();
        }
        else if(digitado2 == PL2_DIREITA){
            this->noPalco[1]->andarParaDireita();
        }
        else if(digitado2 == SEM_TECLA){
            this->noPalco[1]->parou();
        }
    }

    if (digitado1== PL1_BAIXO){
        this->noPalco[0]->andarParaBaixo();
    }
    else if(digitado1 == PL1_CIMA){
        this->noPalco[0]->andarParaCima();
    }
    else if(digitado1 == PL1_ESQUERDA){
        this->noPalco[0]->andarParaEsquerda();
    }
    else if(digitado1 == PL1_DIREITA){
        this->noPalco[0]->andarParaDireita();
    }
    else if(digitado1 == SEM_TECLA){
            this->noPalco[0]->parou();
    }



    if (this->estagioAtual == 1 ) size =19;
    else size = 24;

     if (this->numeroDeJogadores == 2){
            if(this->estagio->y == 0){
                if (this->noPalco[0]->y > 600-60) this->noPalco[0]->y = 600-60;
                if (this->noPalco[1]->y > 600-60) this->noPalco[1]->y = 600-60;
           }
           else{

                if (this->noPalco[0]->y < 480) this->noPalco[0]->y = 480;
                if (this->noPalco[1]->y < 480) this->noPalco[1]->y = 480;
           }
    }

    int i;

    for (i=0; i<size; i++){
        noPalco[i]->andar();
    }

    Retorno retorno1;
    Retorno retorno2;
    retorno1 = this->noPalco[0]->colidir(noPalco, size);
    retorno2 = this->noPalco[1]->colidir(noPalco, size);

    if (digitado1 == TECLA_SECRETA || digitado2 == TECLA_SECRETA){
       if (this->estagioAtual == 1)this->mudarDeEstagio();
       return 1;
    }

    if (retorno1.minhoca || (retorno2.minhoca && this->numeroDeJogadores == 2)){
        bool mudar = this->atualizaMinhoca(noPalco[size-1]);
        if (mudar){
            if (this->estagioAtual == 1){
                this->mudarDeEstagio();
                return 1;
            }
            else{
               return 2;
            }
        }
    }

    if (retorno1.ret == -1){
        noPalco[0]->morreu();
    }
    if (retorno2.ret == -1){
        noPalco[1]->morreu();
    }

    if (this->noPalco[0]->vidas == 0 || ((this->noPalco[0]->vidas + this->noPalco[1]->vidas) == 0 && this->numeroDeJogadores == 2)){
        return -1;
    }


return 0;
}

bool Logica :: atualizaMinhoca(ObjetoPalco* minhoca){
    bool mudarDeNivel = false;

    if(this->numeroDeJogadores == 1){
        minhoca->x = (rand() % (800- 35));
        minhoca->y = minhoca->y - 150;
    }
    else if(this->numeroDeJogadores ==2){
        minhoca->x = (rand() % (800- 35));
        minhoca->y = minhoca->y - 50;
    }

    if(minhoca->y < 0){
        mudarDeNivel = true;
    }

    return mudarDeNivel;

}


bool Logica:: mudarDeEstagio(){
    if (this->estagioAtual == 1){
        estagioAtual = 2;
        noPalco = aux2;
    }
    else{
        return false;
    }

    return true;
}

void  Logica:: toStruct (TLogica *retorno){


	TEstagio est;
	this->estagio->toStruct(&est);
	retorno->estagio = est;
	retorno->numeroDeJogadores = this->numeroDeJogadores;
	retorno->estagioAtual = this->estagioAtual;
	retorno->minhocasComidas = this->minhocasComidas;
	retorno->pausado = this->pausado;

	int i;
	for (i=0; i< 30 ; i++){
		TObjetoPalco aux;
		if (i<20){
			this->aux1[i]->toStruct(&aux);
			retorno->aux1[i] = aux;
		}

		this->aux2[i]->toStruct(&aux);
		retorno->aux2[i] = aux;
	}



}


