//============================================================================
// Name        : TesteServidor.cpp
// Author      :
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include "Criptografia_impl.h"
#include "Servidor_impl.h"
#include "Servidor.h"
#include <coss/CosNaming.h>
#include <iostream>
#include <stdlib.h>
#include "Logica.h"
#include <time.h> /////////////////////////////////////////////////////////

using namespace std;

int main() {

	FILE * in = fopen("Serv.in", "r");

		char par1[100];
		char par2[100];
		char par3[100];

		fscanf(in, "%s", par1);
		fscanf(in, "%s", par2);
		fscanf(in, "%s", par3);

		char *argv[] = { par1, par2, par3 };
		int argc = 3;

		cout << "Initialize the Orb!" << endl;
		CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

		cout << "Obtain a reference to the RootPOA and its Manager!" << endl;
		CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
		PortableServer::POA_var poa = PortableServer::POA::_narrow(poaobj);
		PortableServer::POAManager_var mgr = poa->the_POAManager();


		cout << "obtain a reference to the naming service object" << endl;
		CORBA::Object_var nsobj = orb->resolve_initial_references("NameService");

		cout << "obtain a namecontext" << endl;
		CosNaming::NamingContext_var nc = CosNaming::NamingContext::_narrow(nsobj);

		cout << "create an servidor!" << endl;
		PortableServer::Servant servidor_servant = new Servidor_impl(); //Esta fora de ordem.

		cout << "Activate the servidor!" << endl;
		CORBA::Object_var servidor = servidor_servant->_this(); //Esta fora de ordem.

		cout << "export the servidor ior to the naming service" << endl;
		CosNaming::Name name;
		name.length(1);
		name[0].id = (const char*) "myServidor";
		name[0].kind = (const char*) "";

		nc->rebind(name, servidor);

		cout << "activate the POA and starts serving requests " << endl;
		cout << "running" << endl;


		mgr->activate();
		orb->run();

		cout << "shutdown (never reached)" << endl;
		poa->destroy(TRUE,TRUE);
		delete servidor_servant;

	/*FILE * in = fopen("Serv.in", "r");

	char par1[100];
	char par2[100];
	char par3[100];

	fscanf(in, "%s", par1);
	fscanf(in, "%s", par2);
	fscanf(in, "%s", par3);

	char *argv[] = { par1, par2, par3 };
	int argc = 3;

	cout << "Initialize the Orb!" << endl;
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

	cout << "Obtain a reference to the RootPOA and its Manager!" << endl;
	CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
	PortableServer::POA_var poa = PortableServer::POA::_narrow(poaobj);
	PortableServer::POAManager_var mgr = poa->the_POAManager();

	cout << "create an Criptografia!" << endl;
	PortableServer::Servant criptografia_servant = new Criptografia_impl;

	cout << "Activate the Criptografia!" << endl;
	CORBA::Object_var the_criptografia = criptografia_servant->_this();

	cout << "obtain a reference to the naming service object" << endl;
	CORBA::Object_var nsobj = orb->resolve_initial_references("NameService");

	cout << "obtain a namecontext" << endl;
	CosNaming::NamingContext_var nc = CosNaming::NamingContext::_narrow(nsobj);

	cout << "export the account ior to the naming service" << endl;
	CosNaming::Name name;
	name.length(1);
	name[0].id = (const char*) "myCriptografia";
	name[0].kind = (const char*) "";

	nc->rebind(name, the_criptografia);

	cout << "activate the POA and starts serving requests " << endl;
	cout << "running" << endl;

	mgr->activate();
	orb->run();

	cout << "shutdown (never reached)" << endl;
	poa->destroy(TRUE,TRUE);
	delete criptografia_servant;
	*/
	return 0;
}
