#ifndef TECLADO_H
#define TECLADO_H

#define INTERFACE_PL1   1
#define INTERFACE_PL2   2
#define INTERFACE_MENU  3


#define SEM_TECLA      -1

#define PL1_CIMA        0
#define PL1_BAIXO       1
#define PL1_ESQUERDA    2
#define PL1_DIREITA     3
#define PL1_PAUSE       4

#define PL2_CIMA        5
#define PL2_BAIXO       6
#define PL2_ESQUERDA    7
#define PL2_DIREITA     8
#define PL2_PAUSE       9

#define MENU_CIMA       10
#define MENU_BAIXO      11
#define MENU_AJUDA      12
#define MENU_SELECT     13

#define TECLA_SECRETA   14
#define SAIR_JOGO       15

#include <allegro.h>

class Teclado{

    int interface;
    int verificaPL1();
    int verificaPL2();
    int verificaMenu();


    public:

    Teclado(int _interface);
    ~Teclado();

    int verificaEntradas();


};


#endif
