#ifndef LOGICA_H_INCLUDED
#define LOGICA_H_INCLUDED

#include "Estagio.h"
#include "ObjetoPalco.h"

#include <stdlib.h>

#define SEM_TECLA      -1

#define PL1_CIMA        0
#define PL1_BAIXO       1
#define PL1_ESQUERDA    2
#define PL1_DIREITA     3
#define PL1_PAUSE       4

#define PL2_CIMA        5
#define PL2_BAIXO       6
#define PL2_ESQUERDA    7
#define PL2_DIREITA     8
#define PL2_PAUSE       9

#define MENU_CIMA       10
#define MENU_BAIXO      11
#define MENU_AJUDA      12
#define MENU_SELECT     13

#define TECLA_SECRETA   14
#define SAIR_JOGO       15

/*
#ifndef TLOGICA
#define TLOGICA
typedef struct log {

	TEstagio estagio;
	int numeroDeJogadores;
	int estagioAtual;
	TObjetoPalco * noPalco;
	int minhocasComidas;
	bool pausado;
	TObjetoPalco aux1[20];
	TObjetoPalco aux2[30];

}TLogica;
#endif
*/

class Logica {

public:
	Estagio *estagio;
	int numeroDeJogadores;
	int estagioAtual;
	ObjetoPalco ** noPalco;
	int minhocasComidas;
	bool pausado;
	ObjetoPalco* aux1[20];
	ObjetoPalco* aux2[30];

private:
	void mudarMinhoca();
	bool mudarDeEstagio();
	void moverObjetos();
	bool atualizaMinhoca(ObjetoPalco* minhoca);

public:

	void toStruct(TLogica *retorno);
	Logica(int num);
	~Logica();
	int processar(int digitado, int digitado2);

};

#endif // LOGICA_H_INCLUDED
