#ifndef OBJETOPALCO_H_INCLUDED
#define OBJETOPALCO_H_INCLUDED

#define     CIMA    1
#define    BAIXO    2
#define  DIREITA    3
#define ESQUERDA    4

#define GALINHA1    0
#define GALINHA2    1
#define MINHOCA     10
#define RIO         2
#define JACARE      4
#define TARTARUGA   5
#define BARCO       6
#define TRONCO      7
#define CARRO       8

#define ANDANDO     0
#define PARADO      2
#define MOVENDO     3


#define VEL         3
#define VIDAS       6

#include "Estagio.h"

#include <stdlib.h>

typedef struct t_retorno{
    int ret;
    bool minhoca;
}Retorno;



class ObjetoPalco{


   public:
        int  x;
        int  y;
        int  h;
        int  l;
        int  direcao;
        int estado;
        int pontos;
        int  velocidade;
        int  tipo;
        Estagio* level;
        int vidas;
        bool visivel;


        void morreu();
        void andarDirSobreObj   (int vel);
        bool colidiu (ObjetoPalco* colidido);
        Retorno  colisao(ObjetoPalco* objetoColidido);
        void andarEsqSobreObj   (int vel);
        void tratarColisao (ObjetoPalco * objetoColidido);
        void pontuar();


        ObjetoPalco(Estagio* level, int _tipo, int _x, int _y, int _l, int _h, int _vel, bool _visivel);
        ~ObjetoPalco();



	  void toStruct(TObjetoPalco * retorno);
        void andar();
        void andarParaDireita   ();
        void andarParaEsquerda  ();
        void andarParaCima      ();
        void andarParaBaixo     ();
        void parou              ();
        Retorno colidir             (ObjetoPalco**,int);


};


#endif // OBJETOPALCO_H_INCLUDED
