/*
 * Servidor_impl.cpp
 *
 *  Created on: Dec 6, 2008
 *      Author: user
 */

#include "Servidor_impl.h"
#include "Servidor.h"

Servidor_impl::Servidor_impl() {
	this->logica = new Logica(2);
}

CORBA::Long Servidor_impl::processaJogo(CORBA::Long digitadoPlayer1,
		CORBA::Long qualPlayer) {

	int dig1 = (int) digitadoPlayer1;
	int qlPl = (int) qualPlayer;
	if (qlPl == 1) {
		return (CORBA::Long) this->logica->processar(dig1, -1);
	}
	return (CORBA::Long) this->logica->processar(-1, dig1);
}

TLogica Servidor_impl::getTLogica() {
	TLogica log;
	//this->logica->toStruct(&log);

	log.estagioAtual = (CORBA::Long) this->logica->estagioAtual;
	log.minhocasComidas = (CORBA::Long) this->logica->minhocasComidas;
	log.numeroDeJogadores = (CORBA::Long) this->logica->numeroDeJogadores;
	log.pausado = this->logica->pausado;

	log.estagio.h = (CORBA::Long) this->logica->estagio->h;
	log.estagio.l = (CORBA::Long) this->logica->estagio->l;
	log.estagio.tipo = (CORBA::Long) this->logica->estagio->tipo;
	log.estagio.x = (CORBA::Long) this->logica->estagio->x;
	log.estagio.xInicio1 = (CORBA::Long) this->logica->estagio->xInicio1;
	log.estagio.xInicio2 = (CORBA::Long) this->logica->estagio->xInicio2;
	log.estagio.xMorreu1 = (CORBA::Long) this->logica->estagio->xMorreu1;
	log.estagio.xMorreu2 = (CORBA::Long) this->logica->estagio->xMorreu2;
	log.estagio.y = (CORBA::Long) this->logica->estagio->y;
	log.estagio.yInicio = (CORBA::Long) this->logica->estagio->yInicio;
	log.estagio.yMorreu = (CORBA::Long) this->logica->estagio->yMorreu;

	int i;

	for (i = 0; i < 30; i++) {

		if (i < 20) {
			log.aux1[i].direcao = (CORBA::Long) this->logica->aux1[i]->direcao;

			log.aux1[i].estado = (CORBA::Long) this->logica->aux1[i]->estado;

			log.aux1[i].h = (CORBA::Long) this->logica->aux1[i]->h;
			log.aux1[i].l = (CORBA::Long) this->logica->aux1[i]->l;

			log.aux1[i].level.h = (CORBA::Long) this->logica->aux1[i]->level->h;
			log.aux1[i].level.l = (CORBA::Long) this->logica->aux1[i]->level->l;
			log.aux1[i].level.tipo
					= (CORBA::Long) this->logica->aux1[i]->level->tipo;
			log.aux1[i].level.x = (CORBA::Long) this->logica->aux1[i]->level->x;
			log.aux1[i].level.xInicio1
					= (CORBA::Long) this->logica->aux1[i]->level->xInicio1;
			log.aux1[i].level.xInicio2
					= (CORBA::Long) this->logica->aux1[i]->level->xInicio2;
			log.aux1[i].level.xMorreu1
					= (CORBA::Long) this->logica->aux1[i]->level->xMorreu1;
			log.aux1[i].level.xMorreu2
					= (CORBA::Long) this->logica->aux1[i]->level->xMorreu2;
			log.aux1[i].level.y = (CORBA::Long) this->logica->aux1[i]->level->y;
			log.aux1[i].level.yInicio
					= (CORBA::Long) this->logica->aux1[i]->level->yInicio;
			log.aux1[i].level.yMorreu
					= (CORBA::Long) this->logica->aux1[i]->level->yMorreu;

			log.aux1[i].pontos = (CORBA::Long) this->logica->aux1[i]->pontos;
			log.aux1[i].tipo = (CORBA::Long) this->logica->aux1[i]->tipo;
			log.aux1[i].velocidade
					= (CORBA::Long) this->logica->aux1[i]->velocidade;
			log.aux1[i].vidas = (CORBA::Long) this->logica->aux1[i]->vidas;
			log.aux1[i].visivel = this->logica->aux1[i]->visivel;
			log.aux1[i].x = (CORBA::Long) this->logica->aux1[i]->x;
			log.aux1[i].y = (CORBA::Long) this->logica->aux1[i]->y;
		}

		log.aux2[i].direcao = (CORBA::Long) this->logica->aux2[i]->direcao;
		log.aux2[i].estado = (CORBA::Long) this->logica->aux2[i]->estado;
		log.aux2[i].h = (CORBA::Long) this->logica->aux2[i]->h;
		log.aux2[i].l = (CORBA::Long) this->logica->aux2[i]->l;

		log.aux2[i].level.h = (CORBA::Long) this->logica->aux2[i]->level->h;
		log.aux2[i].level.l = (CORBA::Long) this->logica->aux2[i]->level->l;
		log.aux2[i].level.tipo
				= (CORBA::Long) this->logica->aux2[i]->level->tipo;
		log.aux2[i].level.x = (CORBA::Long) this->logica->aux2[i]->level->x;
		log.aux2[i].level.xInicio1
				= (CORBA::Long) this->logica->aux2[i]->level->xInicio1;
		log.aux2[i].level.xInicio2
				= (CORBA::Long) this->logica->aux2[i]->level->xInicio2;
		log.aux2[i].level.xMorreu1
				= (CORBA::Long) this->logica->aux2[i]->level->xMorreu1;
		log.aux2[i].level.xMorreu2
				= (CORBA::Long) this->logica->aux2[i]->level->xMorreu2;
		log.aux2[i].level.y = (CORBA::Long) this->logica->aux2[i]->level->y;
		log.aux2[i].level.yInicio
				= (CORBA::Long) this->logica->aux2[i]->level->yInicio;
		log.aux2[i].level.yMorreu
				= (CORBA::Long) this->logica->aux2[i]->level->yMorreu;

		log.aux2[i].pontos = (CORBA::Long) this->logica->aux2[i]->pontos;
		log.aux2[i].tipo = (CORBA::Long) this->logica->aux2[i]->tipo;
		log.aux2[i].velocidade
				= (CORBA::Long) this->logica->aux2[i]->velocidade;
		log.aux2[i].vidas = (CORBA::Long) this->logica->aux2[i]->vidas;
		log.aux2[i].visivel = this->logica->aux2[i]->visivel;
		log.aux2[i].x = (CORBA::Long) this->logica->aux2[i]->x;
		log.aux2[i].y = (CORBA::Long) this->logica->aux2[i]->y;

		cout << log.aux1[i].estado << endl;
	}

	return log;
}

